/*******************************************************************************
* File Name: CapSense_Sns.h  
* Version 2.10
*
* Description:
*  This file contains the Alias definitions for Per-Pin APIs in cypins.h. 
*  Information on using these APIs can be found in the System Reference Guide.
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_CapSense_Sns_ALIASES_H) /* Pins CapSense_Sns_ALIASES_H */
#define CY_PINS_CapSense_Sns_ALIASES_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"


/***************************************
*              Constants        
***************************************/
#define CapSense_Sns_0		(CapSense_Sns__0__PC)
#define CapSense_Sns_0_PS		(CapSense_Sns__0__PS)
#define CapSense_Sns_0_PC		(CapSense_Sns__0__PC)
#define CapSense_Sns_0_DR		(CapSense_Sns__0__DR)
#define CapSense_Sns_0_SHIFT	(CapSense_Sns__0__SHIFT)

#define CapSense_Sns_1		(CapSense_Sns__1__PC)
#define CapSense_Sns_1_PS		(CapSense_Sns__1__PS)
#define CapSense_Sns_1_PC		(CapSense_Sns__1__PC)
#define CapSense_Sns_1_DR		(CapSense_Sns__1__DR)
#define CapSense_Sns_1_SHIFT	(CapSense_Sns__1__SHIFT)

#define CapSense_Sns_2		(CapSense_Sns__2__PC)
#define CapSense_Sns_2_PS		(CapSense_Sns__2__PS)
#define CapSense_Sns_2_PC		(CapSense_Sns__2__PC)
#define CapSense_Sns_2_DR		(CapSense_Sns__2__DR)
#define CapSense_Sns_2_SHIFT	(CapSense_Sns__2__SHIFT)

#define CapSense_Sns_3		(CapSense_Sns__3__PC)
#define CapSense_Sns_3_PS		(CapSense_Sns__3__PS)
#define CapSense_Sns_3_PC		(CapSense_Sns__3__PC)
#define CapSense_Sns_3_DR		(CapSense_Sns__3__DR)
#define CapSense_Sns_3_SHIFT	(CapSense_Sns__3__SHIFT)

#define CapSense_Sns_4		(CapSense_Sns__4__PC)
#define CapSense_Sns_4_PS		(CapSense_Sns__4__PS)
#define CapSense_Sns_4_PC		(CapSense_Sns__4__PC)
#define CapSense_Sns_4_DR		(CapSense_Sns__4__DR)
#define CapSense_Sns_4_SHIFT	(CapSense_Sns__4__SHIFT)

#define CapSense_Sns_5		(CapSense_Sns__5__PC)
#define CapSense_Sns_5_PS		(CapSense_Sns__5__PS)
#define CapSense_Sns_5_PC		(CapSense_Sns__5__PC)
#define CapSense_Sns_5_DR		(CapSense_Sns__5__DR)
#define CapSense_Sns_5_SHIFT	(CapSense_Sns__5__SHIFT)

#define CapSense_Sns_6		(CapSense_Sns__6__PC)
#define CapSense_Sns_6_PS		(CapSense_Sns__6__PS)
#define CapSense_Sns_6_PC		(CapSense_Sns__6__PC)
#define CapSense_Sns_6_DR		(CapSense_Sns__6__DR)
#define CapSense_Sns_6_SHIFT	(CapSense_Sns__6__SHIFT)

#define CapSense_Sns_7		(CapSense_Sns__7__PC)
#define CapSense_Sns_7_PS		(CapSense_Sns__7__PS)
#define CapSense_Sns_7_PC		(CapSense_Sns__7__PC)
#define CapSense_Sns_7_DR		(CapSense_Sns__7__DR)
#define CapSense_Sns_7_SHIFT	(CapSense_Sns__7__SHIFT)


#define CapSense_Sns_Up__BTN		(CapSense_Sns__Up__BTN__PC)
#define CapSense_Sns_Up__BTN_PS		(CapSense_Sns__Up__BTN__PS)
#define CapSense_Sns_Up__BTN_PC		(CapSense_Sns__Up__BTN__PC)
#define CapSense_Sns_Up__BTN_DR		(CapSense_Sns__Up__BTN__DR)
#define CapSense_Sns_Up__BTN_SHIFT	(CapSense_Sns__Up__BTN__SHIFT)

#define CapSense_Sns_Down__BTN		(CapSense_Sns__Down__BTN__PC)
#define CapSense_Sns_Down__BTN_PS		(CapSense_Sns__Down__BTN__PS)
#define CapSense_Sns_Down__BTN_PC		(CapSense_Sns__Down__BTN__PC)
#define CapSense_Sns_Down__BTN_DR		(CapSense_Sns__Down__BTN__DR)
#define CapSense_Sns_Down__BTN_SHIFT	(CapSense_Sns__Down__BTN__SHIFT)

#define CapSense_Sns_Left__BTN		(CapSense_Sns__Left__BTN__PC)
#define CapSense_Sns_Left__BTN_PS		(CapSense_Sns__Left__BTN__PS)
#define CapSense_Sns_Left__BTN_PC		(CapSense_Sns__Left__BTN__PC)
#define CapSense_Sns_Left__BTN_DR		(CapSense_Sns__Left__BTN__DR)
#define CapSense_Sns_Left__BTN_SHIFT	(CapSense_Sns__Left__BTN__SHIFT)

#define CapSense_Sns_Right__BTN		(CapSense_Sns__Right__BTN__PC)
#define CapSense_Sns_Right__BTN_PS		(CapSense_Sns__Right__BTN__PS)
#define CapSense_Sns_Right__BTN_PC		(CapSense_Sns__Right__BTN__PC)
#define CapSense_Sns_Right__BTN_DR		(CapSense_Sns__Right__BTN__DR)
#define CapSense_Sns_Right__BTN_SHIFT	(CapSense_Sns__Right__BTN__SHIFT)

#define CapSense_Sns_Start__BTN		(CapSense_Sns__Start__BTN__PC)
#define CapSense_Sns_Start__BTN_PS		(CapSense_Sns__Start__BTN__PS)
#define CapSense_Sns_Start__BTN_PC		(CapSense_Sns__Start__BTN__PC)
#define CapSense_Sns_Start__BTN_DR		(CapSense_Sns__Start__BTN__DR)
#define CapSense_Sns_Start__BTN_SHIFT	(CapSense_Sns__Start__BTN__SHIFT)

#define CapSense_Sns_Select__BTN		(CapSense_Sns__Select__BTN__PC)
#define CapSense_Sns_Select__BTN_PS		(CapSense_Sns__Select__BTN__PS)
#define CapSense_Sns_Select__BTN_PC		(CapSense_Sns__Select__BTN__PC)
#define CapSense_Sns_Select__BTN_DR		(CapSense_Sns__Select__BTN__DR)
#define CapSense_Sns_Select__BTN_SHIFT	(CapSense_Sns__Select__BTN__SHIFT)

#define CapSense_Sns_Back__BTN		(CapSense_Sns__Back__BTN__PC)
#define CapSense_Sns_Back__BTN_PS		(CapSense_Sns__Back__BTN__PS)
#define CapSense_Sns_Back__BTN_PC		(CapSense_Sns__Back__BTN__PC)
#define CapSense_Sns_Back__BTN_DR		(CapSense_Sns__Back__BTN__DR)
#define CapSense_Sns_Back__BTN_SHIFT	(CapSense_Sns__Back__BTN__SHIFT)

#define CapSense_Sns_Coin__BTN		(CapSense_Sns__Coin__BTN__PC)
#define CapSense_Sns_Coin__BTN_PS		(CapSense_Sns__Coin__BTN__PS)
#define CapSense_Sns_Coin__BTN_PC		(CapSense_Sns__Coin__BTN__PC)
#define CapSense_Sns_Coin__BTN_DR		(CapSense_Sns__Coin__BTN__DR)
#define CapSense_Sns_Coin__BTN_SHIFT	(CapSense_Sns__Coin__BTN__SHIFT)


#endif /* End Pins CapSense_Sns_ALIASES_H */


/* [] END OF FILE */
