/*******************************************************************************
* File Name: Vref.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_Vref_H) /* Pins Vref_H */
#define CY_PINS_Vref_H

#include "cytypes.h"
#include "cyfitter.h"
#include "Vref_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    Vref_Write(uint8 value) ;
void    Vref_SetDriveMode(uint8 mode) ;
uint8   Vref_ReadDataReg(void) ;
uint8   Vref_Read(void) ;
uint8   Vref_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define Vref_DRIVE_MODE_BITS        (3)
#define Vref_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - Vref_DRIVE_MODE_BITS))

#define Vref_DM_ALG_HIZ         (0x00u)
#define Vref_DM_DIG_HIZ         (0x01u)
#define Vref_DM_RES_UP          (0x02u)
#define Vref_DM_RES_DWN         (0x03u)
#define Vref_DM_OD_LO           (0x04u)
#define Vref_DM_OD_HI           (0x05u)
#define Vref_DM_STRONG          (0x06u)
#define Vref_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define Vref_MASK               Vref__MASK
#define Vref_SHIFT              Vref__SHIFT
#define Vref_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define Vref_PS                     (* (reg32 *) Vref__PS)
/* Port Configuration */
#define Vref_PC                     (* (reg32 *) Vref__PC)
/* Data Register */
#define Vref_DR                     (* (reg32 *) Vref__DR)
/* Input Buffer Disable Override */
#define Vref_INP_DIS                (* (reg32 *) Vref__PC2)


#if defined(Vref__INTSTAT)  /* Interrupt Registers */

    #define Vref_INTSTAT                (* (reg32 *) Vref__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define Vref_DRIVE_MODE_SHIFT       (0x00u)
#define Vref_DRIVE_MODE_MASK        (0x07u << Vref_DRIVE_MODE_SHIFT)


#endif /* End Pins Vref_H */


/* [] END OF FILE */
